﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_expander
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Select a state.
            cboState.SelectedIndex = 0;
        }

        // The expander's current state.
        private bool Expanded = false;

        // Start expanding.
        private void btnExpander_Click(object sender, EventArgs e)
        {
            if (Expanded)
            {
                btnExpander.Image = Properties.Resources.expander_down;
                tmrCollapse.Enabled = true;
                tmrExpand.Enabled = false;
            }
            else
            {
                btnExpander.Image = Properties.Resources.expander_up;
                tmrExpand.Enabled = true;
                tmrCollapse.Enabled = false;
            }
            Expanded = !Expanded;
        }

        // The number of pixels expanded per timer Tick.
        private const int ExpansionPerTick = 7;

        // Make the expander panel bigger.
        private void tmrExpand_Tick(object sender, EventArgs e)
        {
            int new_height = panAddress.Height + ExpansionPerTick;
            if (new_height >= panAddress.MaximumSize.Height)
            {
                tmrExpand.Enabled = false;
                new_height = panAddress.MaximumSize.Height;
            }

            panAddress.Height = new_height;
        }

        // Make the expander panel smaller.
        private void tmrCollapse_Tick(object sender, EventArgs e)
        {
            int new_height = panAddress.Height - ExpansionPerTick;
            if (new_height <= panAddress.MinimumSize.Height)
            {
                tmrCollapse.Enabled = false;
                new_height = panAddress.MinimumSize.Height;
            }

            panAddress.Height = new_height;
        }
    }
}
